## apache-pulsar-2.7.4-src.tar.gz

=== dashboard/requirements.txt ===
chardet
Django <2.0
hexdump
psycopg2
pulsar-client
pytz
requests
uwsgi
